import os
import sys

csound = "csound"
flags = "-K -W -d"

testFiles = [
"0dbfs",
"abs",
"active",
"active_k",
"adds",
"adsr",
"adsyn",
"adsynt",
#"aftouch",
"alpass",
"ampdb",
"ampdbfs",
#"ampmidi",
"babo",
"babo_expert",
"balance",
"bamboo",
"betarand",
"bexprnd",
"biquad",
"birnd",
"butterbp",
"butterbr",
"butterhp",
"butterlp",
"buzz",
"cabasa",
"cauchy",
"cent",
"cggoto",
"checkbox",
"cigoto",
"ckgoto",
"clfilt_highpass",
"clfilt_lowpass",
"clip",
"comb",
"cos",
"cosh",
"cosinv",
"cps2pch",
"cps2pch_19et",
"cps2pch_ftable",
#"cpsmidi",
#"cpsmidib",
"cpsoct",
"cpspch",
#"cpstmid",
"cpstun",
"cpstuni",
"cpsxpch",
"cpsxpch_105et",
"cpsxpch_pierce",
"cpuprc",
"crunch",
"dam",
"dam_expanded",
"db",
"dbamp",
"dbfsamp",
"dcblock",
"dconv",
"define",
"define_args",
"delay",
"delayw",
"diff",
"diskin",
"dispfft",
"display",
"distort1",
"divides",
"divz",
"downsamp",
"dripwater",
"endin",
"envlpx",
"equal",
"event",
"exp",
"expon",
"exprand",
"expseg",
"expsega",
"expsegr",
"filelen",
"filenchnls",
"filepeak",
"filesr",
"flanger",
"flashtxt",
"fmb3",
"fmbell",
"fmmetal",
"fmpercfl",
"fmrhode",
"fmvoice",
"fmwurlie",
"fof",
"fold",
"follow",
"follow2",
"foscil",
"foscili",
"frac",
"ftchnls",
"ftgen",
"ftlen",
"ftlptim",
"ftmorf",
"ftsr",
"gauss",
"gbuzz",
"gogobel",
"goto",
"grain",
"grain2",
"grain3",
"granule",
"greaterequal",
"greaterthan",
"guiro",
"harmon",
"hilbert",
"hilbert_barberpole",
"hrtfer",
"hsboscil",
#"hsboscil_midi",
"igoto",
"ihold",
"include",
"instr",
"int",
"integ",
"interp",
"jitter",
"jitter2",
"kgoto",
"lessequal",
"lessthan",
"lfo",
"line",
"linrand",
"linseg",
"linsegr",
"log",
"log10",
"logbtwo",
"loopseg",
"lorenz",
"loscil",
"loscil3",
"lowpass2",
"lowres",
"lowresx",
"lpf18",
"lpshold",
"mandol",
"marimba",
"maxalloc",
#"midichannelaftertouch",
#"midichn",
#"midichn_advanced",
#"midinoteoff",
#"midinoteoncps",
#"midinoteonkey",
#"midinoteonoct",
#"midinoteonpch",
#"midipitchbend",
"modulus",
"moog",
"moogvcf",
"mpulse",
"multiplies",
"nestedap",
"noise",
"notequal",
"notnum",
"nreverb",
"nreverb_ftable",
"nsamp",
"octave",
"octcps",
#"octmidi",
#"octmidib",
"octpch",
"oscbnk",
"oscil",
"oscil3",
"oscili",
"oscils",
"p",
"pareq",
"pcauchy",
"pchbend",
#"pchmidi",
#"pchmidib",
"pchoct",
"peak",
"pgmassign",
"pgmassign_advanced",
"pgmassign_ignore",
"phaser1",
"phaser2",
"phasor",
"phasorbnk",
"pinkish",
"pitch",
"pitchamdf",
"pluck",
"poisson",
"polyaft",
"poscil",
"poscil3",
"pow",
"powoftwo",
"prealloc",
"print",
"printk",
"printk2",
"printks",
"raises",
"rand",
"randh",
"randi",
"random",
"randomh",
"randomi",
"readclock",
"reinit",
"repluck",
"reson",
"resonr",
"resony",
"reverb",
"rezzy",
"rnd",
"rnd31",
"rnd31_krate",
"rnd31_seed7",
"rnd31_time",
"rtclock",
"sandpaper",
"scans",
"scantable",
"schedkwhen",
"schedule",
"schedwhen",
"sekere",
"semitone",
"sensekey",
"setctrl",
"shaker",
"sin",
"sinh",
"sininv",
"sleighbells",
"soundin",
"spat3d_UHJ",
"spat3d_quad",
"spat3d_stereo",
"sqrt",
"stix",
"streson",
"subtracts",
"svfilter",
"table",
"tambourine",
"tan",
"tanh",
"taninv",
"taninv2",
"tbvcf",
"tempest",
"tempo",
"tempoval",
"timeinstk",
"timeinsts",
"timek",
"times",
"trigger",
"trirand",
"turnoff",
"unirand",
"vco",
"veloc",
"vibes",
"vibr",
"vibrato",
"vlowres",
"voice",
"waveset",
"weibull",
"wgbow",
"wgbowedbar",
"wgbrass",
"wgclar",
"wgflute",
"wgpluck",
"wgpluck2",
"wgpluck_brighter",
"wterrain",
"xyin",
"zacl",
"zakinit",
"zamod",
"zar",
"zarg",
"zaw",
"zawm",
"zir",
"ziw",
"ziwm",
"zkcl",
"zkmod",
"zkr",
"zkw",
"zkwm"]


###############################################################################


if len(sys.argv) == 2:
    csound = sys.argv[1]

print "Using Csound Command: " + csound    

try:
    os.remove("Old_Output")
except OSError:
    pass

try:
    os.remove("CheckSums")
except OSError:
    pass

try:
    os.rename("Output", "Old_Output")
except OSError:
    pass

for filename in testFiles:

    replaceText = (csound, flags, filename, filename, filename)
    csCommand = "%s %s %s.orc %s.sco -o ./%s.wav >> Output"%replaceText
  
    md5sumCommand = "md5sum -b %s.wav >> CheckSums"%filename

    print csCommand
    os.system(csCommand)
    os.system(md5sumCommand)

    try:
        os.remove(filename + ".wav")
    except OSError:
        print "Error: %s.wav was not generated"%filename
    
os.system("diff CheckSums SAFESums")
os.system("diff Output Old_Output")
